package bintools

import net.sergeych.bintools.MRUCache
import net.sergeych.bintools.toDump
import kotlin.test.Test
import kotlin.test.assertEquals
import kotlin.test.assertNull
import kotlin.test.assertTrue

class TestTools {
    @Test
    fun testDump() {
//        val src =
//            "MfsmHUExZpb3xd0X8FVj2MSOxc1dRd-93i3zkmJVhgWH0r8p0Agtg6lc9_TB6srlXJF4MOWT3a_Cfy87W3FTKRzdCdsAEDOBkSL-JANDey4"
//                .decodeBase64Url()
//        println(src.toDump())
        var res = byteArrayOf(0)
        for( i in 1..100) {
            res += byteArrayOf(i.toByte())
            println(res.toDump())
        }
    }

    @Test
    fun testCache() {
        val cache = MRUCache<Int,String>(3)
        cache.putAll( mapOf(1 to "one", 2 to "two", 3 to "three", 4 to "four" ) )
        assertNull(cache[0])

        // this actually should reset MRU for 2:
        assertEquals("two", cache[2])
        assertNull(cache[1])
        assertEquals(3, cache.size)
        assertTrue { 3 in cache }
        assertTrue { 4 in cache }

    // now MRU is 2 (checked in assertEquals above) so LRU to drop is 3!
        cache[5] = "five"
        assertEquals(3, cache.size)
        assertTrue { 2 in cache }
        assertTrue { 4 in cache }
        assertTrue { 5 in cache }

        cache.getOrPut(3) { "new three"}
        assertEquals(3, cache.size)
        assertTrue { 2 in cache }
        assertTrue { 3 in cache }
        assertTrue { 5 in cache }

        cache[2] = "New Two"
        cache[6] = "six"

        // 2 is now second used
        // amd 6 is MRU, oldest is therefore 5

        assertEquals(3, cache.size)
        assertTrue { 2 in cache }
        assertTrue { 6 in cache }
        assertTrue { 3 in cache }
    }
}